#include <gl/gl.h>
#define	CON_RGB(r,g,b)	(r+(g*256)+(b*256*256))
#define SQR(x)	((x)*(x))
#define DEBUGGING 0	/* 0 = off 1 = on */

/* I got these from FACES/4Ver point editing (middle mouse button) */
#define TOP_X  (-4.136) /* really left_x */
#define BOT_X  (-TOP_X) /* and rightmost x my face is symmetric */

#define TOP_Y  ( 7.522)
#define BOT_Y  ( -8.714)




#define WINXS -10	/* Orthogonal Window Boundary */
#define WINXE 10
#define WINYS -10
#define WINYE 10
#define WINZS -15
#define WINZE 10

#define P_WINXS -1	/* Perspective Window Boundary */
#define P_WINXE 1
#define P_WINYS -1
#define P_WINYE 1
#define P_WINZS 15
#define P_WINZE 20000


typedef struct {
    Coord	vx,vy,vz;		/* Point looking at */
    Coord	px,py,pz;		/* Point looking from (eye position)*/
    Angle	twist;			/* twist about z ? */

} camera_pos;



typedef	struct {
    short	movie;
    short	ortho;
    short	texture;
    short	light;
    short	disp_musc;
} cntrl_options;


typedef struct {
    float       xpos;
    float       ypos;
    float       zpos;
    float       dist;   /* distance between the two eyeballs */
    long        xrot;   /* x-rotation of  eyeball */
    long        yrot;   /* y-rotation of  eyeball */
    float       pupil;  /* 0..1 pupil dilation */
    float       iris;   /* 0..1 iris size */
    float       size;   /* amount to scale the eyeball (its radius) */
} eye_info;


typedef struct {
    float	xrot;
    float	yrot;
    float	zrot;
    float	xpos;
    float	ypos;
    float	zpos;
} head_info;












